clear i_1 i_2 i_3 i_neg_3 i_neg_2 solve_time_1 solve_time_2 solve_time_3 solve_time_neg_3 solve_time_neg_2

i_1 = 1;
i_2 = 1;
i_3 = 1;
i_neg_3 = 1;
i_neg_2 = 1;
for i = 1:size(solve_time(1,:),2)
    if error_flag(2,i) == 1 
       solve_time_1(:,i_1) = solve_time(:,i);
       i_1 = i_1 + 1;
    elseif (error_flag(2,i) == 2 )
        solve_time_2(:,i_2) = solve_time(:,i);
       i_2 = i_2 + 1;
    elseif (error_flag(2,i) == 3 )
        solve_time_3(:,i_3) = solve_time(:,i);
       i_3 = i_3 + 1;
    elseif (error_flag(2,i) == -3 )
        solve_time_neg_3(:,i_neg_3) = solve_time(:,i);
       i_neg_3 = i_neg_3 + 1;
    elseif (error_flag(2,i) == -2 )
        solve_time_neg_2(:,i_neg_2) = solve_time(:,i);
       i_neg_2 = i_neg_2 + 1;
    end
end        
        
%%    
figure(2)
plot(solve_time(1,:), solve_time(2,:), 'b'), grid, hold on
if (i_1 > 1)
    legend_solve_1 = scatter(solve_time_1(1,:), solve_time_1(2,:), 'k', 'Filled');
end    
if (i_2 > 1)
legend_solve_2 = scatter(solve_time_2(1,:), solve_time_2(2,:), 'k', 'd');
end
if (i_neg_2 > 1)
legend_solve_neg_2 = scatter(solve_time_neg_2(1,:), solve_time_neg_2(2,:), 'k', '^', 'Filled');
end
if (i_3 > 1)
legend_solve_3 = scatter(solve_time_3(1,:), solve_time_3(2,:), 'k', '>');
end
if (i_neg_3 > 1)
legend_solve_neg_3 = scatter(solve_time_neg_3(1,:), solve_time_neg_3(2,:), 'k', '<');
end
%legend([legend_solve_1,legend_solve_2,legend_solve_neg_2,legend_solve_3,legend_solve_neg_3], ...
%       {'solved', 'solved inaccurate', 'max iteration reached', 'primal infeasible inaccurate', 'primal infeasible'})
%legend([legend_solve_1,legend_solve_2,legend_solve_neg_2,legend_solve_neg_3], ...
%       {'solved', 'solved inaccurate', 'max iteration reached', 'primal infeasible'})
%legend([legend_solve_1,legend_solve_2,legend_solve_neg_2], ...
%       {'solved', 'solved inaccurate', 'max iteration reached'})
%legend([legend_solve_1,legend_solve_2], ...
%       {'solved', 'solved inaccurate'})
legend([legend_solve_1], ...
       {'solved'})   
title_fig = ['Solve time for OSQP'];
title(title_fig)
ylim1 = min(solve_time(2,:));
ylim2 = max(solve_time(2,:));
ylim([ylim1 ylim2])
ylabel('solve time (s)')
xlabel('time (s)')
mean_solve_time = mean(solve_time(2,:))
var_solve_time = var(solve_time(2,:))