function w = gen_disturbance(problem)

% create random disturbance sequence

disturbance_set = Polyhedron(problem.disturbance.E, problem.disturbance.g);
W_vertices = size(disturbance_set.V,1);
w = zeros(size(problem.disturbance.E,2), problem.system.N);
range = disturbance_set.V(1) - disturbance_set.V(2);

for i=1:2:problem.system.Nsim
    w(:,i) = range.*rand() + disturbance_set.V(2);
    w(:,i+1) = w(:,i);
end    