time_s = 0:system.h:system.h*(system.Nsim-1);
solve_time_sim = [time_s; run_time_sim];
i_1 = 1;
i_2 = 1;
i_3 = 1;
i_neg_3 = 1;
i_neg_2 = 1;
for i = 1:system.Nsim
    if e_flag(i) == 1 
       solve_time_sim_1(:,i_1) = solve_time_sim(:,i);
       i_1 = i_1 + 1;
    elseif (e_flag(i) == 2 )
        solve_time_sim_2(:,i_2) = solve_time_sim(:,i);
       i_2 = i_2 + 1;
    elseif (e_flag(i) == 3 )
        solve_time_sim_3(:,i_3) = solve_time_sim(:,i);
       i_3 = i_3 + 1;
    elseif (e_flag(i) == -3 )
        solve_time_sim_neg_3(:,i_neg_3) = solve_time_sim(:,i);
       i_neg_3 = i_neg_3 + 1;
    elseif (e_flag(i) == -2 )
        solve_time_sim_neg_2(:,i_neg_2) = solve_time_sim(:,i);
       i_neg_2 = i_neg_2 + 1;
    end
end        
        
%%    
figure()
plot(time_s(1,:), solve_time_sim(2,:)), grid, hold on
if (i_1 > 1)
    legend_solve_1 = scatter(solve_time_sim_1(1,:), solve_time_sim_1(2,:), 'k');
end    
if (i_2 > 1)
legend_solve_2 = scatter(solve_time_sim_2(1,:), solve_time_sim_2(2,:), 'k', 'd');
end
if (i_neg_2 > 1)
legend_solve_neg_2 = scatter(solve_time_neg_2(1,:), solve_time_sim_neg_2(2,:), 'k', '^', 'Filled');
end
if (i_3 > 1)
legend_solve_3 = scatter(solve_time_sim_3(1,:), solve_time_sim_3(2,:), 'k', '>');
end
if (i_neg_3 > 1)
legend_solve_neg_3 = scatter(solve_time_sim_neg_3(1,:), solve_time_sim_neg_3(2,:), 'k', 'v');
end
%legend([legend_solve_1,legend_solve_2,legend_solve_neg_2,legend_solve_3,legend_solve_neg_3], ...
%       {'solved', 'solved inaccurate', 'max iteration reached', 'primal infeasible inaccurate', 'primal infeasible'})
%legend([legend_solve_1,legend_solve_2,legend_solve_neg_2], ...
%       {'solved', 'solved inaccurate', 'max iteration reached'})

legend(legend_solve_1, 'solved')   
title_fig = ['Run time of OSQP from helicopter simulation'];
title(title_fig)
ylim1 = min(solve_time_sim(2,:)) - 0.0000001;
ylim2 = max(solve_time_sim(2,:)) + 0.0000001;
ylim([ylim1 ylim2])
ylabel('solve time (s)')
xlabel('time (s)')
mean(solve_time_sim(2,:))
var(solve_time_sim(2,:))
clear legend_solve_1 legend_solve_2 legend_solve_3 legend_solve_neg_3 legend_solve_neg_2